#!/bin/sh

# Exit if any of the command doesn't exit with code 0
set -e

test -z "$EXEC_DIR" && EXEC_DIR=.
test -z "$VENV_PATH" && VENV_PATH="$EXEC_DIR/venv"

activate(){
	if [ ! -d "$VENV_PATH" ]; then
		echo 'Creating python virtual environnement'
		python -m venv "$VENV_PATH"
		echo 'Activating virtual environnement'
		activate
		echo 'Updating base pip packages'
		python -m pip install -U setuptools pip
		echo 'Installing requirements'
		pip install -r requirements.txt
	elif [ -f "$VENV_PATH"/Scripts/activate ]; then . "$VENV_PATH"/Scripts/activate
	elif [ -f "$VENV_PATH"/bin/activate ]; then . "$VENV_PATH"/bin/activate
	else
		echo 'Python virtual environnement not detected'
		exit 1
	fi
}

activate
